﻿#undef NDEBUG
#include <assert.h>

#ifdef UNICODE
#define _UNICODE
#endif

#include <windows.h>
#include "win32.h"
#include "win32_print.h"
#include "win32_vector.h"
#include "tlsdecl.h"

//#include <stdint.h>
#include "MemoryModule.h"

#include <tchar.h>
#include <stdio.h>
#include <malloc.h>

#define DBG(format, ...) win32_printfA("[WMAIN(A)] " format "\n", ## __VA_ARGS__)
#define DBGW(format, ...) win32_printfW(L"[WMAIN(W)] " format L"\n", ## __VA_ARGS__)

static int RunFromMemory(void);

int wmain(int argc, wchar_t *argv[])
{
	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	DBG("wmain() called");
	
	win32_debug_set(true);

#if 0x1
	HANDLE v_thread_heap = win32_thread_heap();
	DBG("wmain(): v_thread_heap=0x%08x", v_thread_heap);
	void *v_memory = win32_thread_malloc(1024);
	DBG("wmain(): v_memory=0x%08x", v_memory);
	void *v_memory2 = win32_thread_malloc(1024);
	DBG("wmain(): v_memory2=0x%08x", v_memory2);
	size_t v_size2 = win32_thread_memlen(v_memory2);
	DBG("wmain(): v_size2=%u", v_size2);
	void *v_memory3 = win32_thread_realloc(v_memory2, 1026);
	DBG("wmain(): v_memory3=0x%08x", v_memory3);
	size_t v_size3 = win32_thread_memlen(v_memory3);
	DBG("wmain(): v_size3=%u", v_size3);
	win32_thread_free(v_memory);
#endif
	static TLS_VARIABLE_DECL char *s_vector = NULL;
	size_t v_memlen1 = win32_thread_memlen(s_vector);
	DBG("wmain(): v_memlen1=%u", v_memlen1);
	DBG("wmain(): win32_thread_char_size(&s_vector)=%u", win32_thread_char_size(&s_vector));
	win32_thread_char_resize(&s_vector, 5);
	size_t v_memlen2 = win32_thread_memlen(s_vector);
	DBG("wmain(): v_memlen2=%u", v_memlen2);
	DBG("wmain(): win32_thread_char_size(&s_vector)=%u", win32_thread_char_size(&s_vector));
	static TLS_VARIABLE_DECL char *s_vector2 = NULL;
	win32_thread_char_push_back(&s_vector2, 'a');
	win32_thread_char_push_back(&s_vector2, 'b');
	win32_thread_char_push_back(&s_vector2, ' ');
	win32_thread_char_push_back(&s_vector2, 'c');
	win32_thread_char_push_back(&s_vector2, 0);
	win32_thread_char_insert(&s_vector2, 0, 'Z');
	DBG("wmain(): win32_thread_char_size(&s_vector2)=%u", win32_thread_char_size(&s_vector2));
	DBG("wmain(): s_vector2=%s", s_vector2);
	char erase1 = win32_thread_char_erase(&s_vector2, 0); UNREFERENCED_PARAMETER(erase1);
	char erase2 = win32_thread_char_erase(&s_vector2, 1); UNREFERENCED_PARAMETER(erase2);
	DBG("wmain(): s_vector2(after erase)=%s", s_vector2);
	DBG("wmain(): win32_thread_char_size(&s_vector2)=%u", win32_thread_char_size(&s_vector2));
	//win32_thread_char_resize(&s_vector2, 0);
	//win32_thread_char_clear(&s_vector2);
	DBG("ワイド文字列1＝%S", L"漢字");
	DBG("ワイド文字列2＝%s", L"漢字");
	DBGW(L"ワイド文字列3＝%s", L"漢字");

	win32_thread_char_reserve(&s_vector2, 20);
	DBG("wmain(): win32_thread_char_size(&s_vector2)=%u", win32_thread_char_size(&s_vector2));
	win32_thread_char_reserve(&s_vector2, 15);
	DBG("wmain(): win32_thread_char_size(&s_vector2)=%u", win32_thread_char_size(&s_vector2));
	
	char c0 = win32_thread_char_get(&s_vector2, 0);
	DBG("wmain(): c0=%c", c0);
	win32_thread_char_set(&s_vector2, 4096, 'X');
	char c4096 = win32_thread_char_get(&s_vector2, 4096);
	DBG("wmain(): c4096=%d (%c)", c4096, c4096);
	DBG("wmain(): win32_thread_char_size(&s_vector2)=%u", win32_thread_char_size(&s_vector2));

	static TLS_VARIABLE_DECL wchar_t *s_wvector = NULL;
	win32_thread_wchar_push_back(&s_wvector, L'A');
	win32_thread_wchar_push_back(&s_wvector, L'B');
	win32_thread_wchar_push_back(&s_wvector, L'C');
	win32_thread_wchar_push_back(&s_wvector, 0);
	DBGW(L"wmain(): s_wvector=%s", s_wvector);
	wchar_t ec1 = win32_thread_wchar_erase(&s_wvector, 1);
	DBGW(L"wmain(): ec1=%c", ec1);
	DBGW(L"wmain(): s_wvector=%s", s_wvector);
	win32_thread_wchar_insert(&s_wvector, 1, L'漢');
	DBGW(L"wmain(): s_wvector=%s", s_wvector);

	RunFromMemory();

	DBG("wmain(end))");

	return 0;
}

//PeLdrSetExecutablePath(&peLdr, (wchar_t *)L"V:\\QtBuild\\#svn\\qt5.4.0\\#labo\\browser5.4.0\\release\\browser.exe");
//PeLdrSetExecutablePath(&peLdr, (wchar_t *)L"V:\\QtBuild\\#svn\\qt5.4.0\\#labo\\tls_01\\release\\main.exe");

//#define EXE_FILE TEXT("V:\\QtBuild\\#svn\\qt5.4.0\\#labo\\tls_01\\release\\main.exe")
#define EXE_FILE TEXT("V:\\QtBuild\\#svn\\qt5.4.0\\#labo\\browser5.4.0\\release\\browser.exe")

int RunFromMemory(void)
{
	FILE *fp;
	unsigned char *data=NULL;
	size_t size;
	HMEMORYMODULE handle;
	int result = -1;
	fp = _tfopen(EXE_FILE, _T("rb"));
	if (fp == NULL)
	{
	_tprintf(_T("Can't open executable \"%s\"."), EXE_FILE);
	goto exit;
	}
	fseek(fp, 0, SEEK_END);
	size = ftell(fp);
	data = (unsigned char *)malloc(size);
	fseek(fp, 0, SEEK_SET);
	fread(data, 1, size, fp);
	fclose(fp);
	handle = MemoryLoadLibrary(data);
	if (handle == NULL)
	{
	_tprintf(_T("Can't load library from memory.\n"));
	goto exit;
	}
	result = MemoryCallEntryPoint(handle);
	if (result < 0) {
	_tprintf(_T("Could not execute entry point: %d\n"), result);
	}
	MemoryFreeLibrary(handle);
	exit:
	if (data)
	free(data);
	return result;
}

